package sun.management;

import java.security.AccessController;
import java.security.PrivilegedAction;
import java.io.IOException;
import java.io.File;

public class FileSystemImpl extends FileSystem
{
    public FileSystemImpl() {
    }
    
    @Override
    public boolean supportsFileSecurity(File file) throws IOException {
        return isSecuritySupported0(file.getAbsolutePath());
    }
    
    @Override
    public boolean isAccessUserOnly(File file) throws IOException {
        String absolutePath = file.getAbsolutePath();
        if (!isSecuritySupported0(absolutePath)) {
            throw new UnsupportedOperationException("File system does not support file security");
        }
        return isAccessUserOnly0(absolutePath);
    }
    
    static native void init0();
    
    static native boolean isSecuritySupported0(String p0) throws IOException;
    
    static native boolean isAccessUserOnly0(String p0) throws IOException;
    
    static {
        AccessController.doPrivileged(new PrivilegedAction<Void>() {
            @Override
            public Void run() {
                System.loadLibrary("management");
                return null;
            }
        });
        init0();
    }
}
